unit Config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, GlobalConst, CommonProc, ComCtrls, ImgList, jpeg,
  XPMan, Buttons, ExtDlgs;

type
  TConfigedFm = class(TForm)
    Panel1: TPanel;
    PrevBt: TButton;
    NextBt: TButton;
    CancelBt: TButton;
    Panel2: TPanel;
    OpenIniDialog: TOpenDialog;
    SaveIniDialog: TSaveDialog;
    SelectTreeStateImg: TImageList;
    SelectTreeImg: TImageList;
    Image2: TImage;
    Label8: TLabel;
    XPManifest1: TXPManifest;
    Label14: TLabel;
    Bevel1: TBevel;
    OpenPictureDialog1: TOpenPictureDialog;
    WizardNb: TNotebook;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label38: TLabel;
    Label60: TLabel;
    NewProjectRb: TRadioButton;
    OpenProjectRb: TRadioButton;
    FileNameEdit: TEdit;
    SelFileBt: TButton;
    LastProjectRb: TRadioButton;
    HeaderScrollBox: TScrollBox;
    GroupBox10: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    PrVersionEdit: TEdit;
    PrTimeEd: TEdit;
    PrAutorEdit: TEdit;
    PrDeskrEdit: TEdit;
    Button8: TButton;
    Button9: TButton;
    Button22: TButton;
    GroupBox12: TGroupBox;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    PrRootEdit: TEdit;
    PrTagEdit: TEdit;
    PrLogEdit: TEdit;
    PrRootEditBt: TButton;
    PrTagEditBt: TButton;
    PrLogEnableCb: TCheckBox;
    PrLogDetalizeCb: TCheckBox;
    PrFddDriveCb: TCheckBox;
    PrFlashDriveCb: TCheckBox;
    PrHddDriveCb: TCheckBox;
    PrLanDriveCb: TCheckBox;
    PrCDdriveCb: TCheckBox;
    PrRunOnceEditRb: TRadioButton;
    PrRunEditRb: TRadioButton;
    PrRunOnceEdit: TEdit;
    PrRunEdit: TEdit;
    Button23: TButton;
    GroupBox11: TGroupBox;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    PrIconLibEdit: TEdit;
    PrScrShotFolderEdit: TEdit;
    PrReadMeFileEdit: TEdit;
    PrLicenseFileEdit: TEdit;
    PrAdminRightCb: TCheckBox;
    PrWelcomPageCb: TCheckBox;
    PrCloseMsgCb: TCheckBox;
    PrAutocloseCb: TCheckBox;
    PrShowLogCb: TCheckBox;
    PrBlockUserInputCb: TCheckBox;
    PrWaitTimerEdit: TEdit;
    UpDown2: TUpDown;
    PrIconLibEditBt: TButton;
    PrScrShotFolderEditBt: TButton;
    PrReadMeFileEditBt: TButton;
    PrLicenseFileEditBt: TButton;
    Button24: TButton;
    PostParamScrollBox: TScrollBox;
    GroupBox9: TGroupBox;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label59: TLabel;
    PostInstallBeforeRegEdit: TEdit;
    PostInstallBeforeRegEditBt: TButton;
    PostInstallAfterRegEdit: TEdit;
    PostInstallAfterRegEditBt: TButton;
    PostInstallFolderEdit: TEdit;
    PostInstallFolderEditBt: TButton;
    Button26: TButton;
    PostInstallCommandEdit4: TEdit;
    PostInstallCommandEdit3: TEdit;
    PostInstallCommandEdit2: TEdit;
    PostInstallCommandEdit1: TEdit;
    PostInstallCommandEdit1Bt: TButton;
    PostInstallCommandEdit2Bt: TButton;
    PostInstallCommandEdit3Bt: TButton;
    PostInstallCommandEdit4Bt: TButton;
    GroupBox2: TGroupBox;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    PreInstallCommandEdit1: TEdit;
    PreInstallCommandEdit1Bt: TButton;
    PreInstallCommandEdit2: TEdit;
    PreInstallCommandEdit2Bt: TButton;
    PreInstallCommandEdit3: TEdit;
    PreInstallCommandEdit3Bt: TButton;
    PreInstallCommandEdit4: TEdit;
    PreInstallCommandEdit4Bt: TButton;
    PreInstallBeforeRegEdit: TEdit;
    PreInstallBeforeRegEditBt: TButton;
    PreInstallAfterRegEdit: TEdit;
    PreInstallAfterRegEditBt: TButton;
    PreInstallFolderEdit: TEdit;
    Button14: TButton;
    Button25: TButton;
    GroupBox15: TGroupBox;
    Button3: TButton;
    GroupBox3: TGroupBox;
    Button27: TButton;
    CloseProgRb: TRadioButton;
    RebootRb: TRadioButton;
    PowerOffBt: TRadioButton;
    GroupBox13: TGroupBox;
    GroupListBox: TListBox;
    Panel3: TPanel;
    GrpDelBt: TButton;
    GrpAddBt: TButton;
    GrpUpBt: TBitBtn;
    GrpDownBt: TBitBtn;
    GroupBox14: TGroupBox;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    NameGroupEd: TEdit;
    DescrGroupEd: TMemo;
    NormGroupRb: TRadioButton;
    ExpandGroupRb: TRadioButton;
    BlockedGroupRb: TRadioButton;
    GroupBox: TGroupBox;
    SelectProgTree: TTreeView;
    PrgItemEditPanel: TPanel;
    PrgDeleteBt: TButton;
    PrgAddBt: TButton;
    PrgUpBt: TBitBtn;
    PrgDownBt: TBitBtn;
    PrgBox: TGroupBox;
    GroupWarningLabel: TLabel;
    PrgScrollBox: TScrollBox;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    GroupCb2: TComboBox;
    PrgNameEd: TEdit;
    PrgDiskrEd: TMemo;
    PrgFolderEdBt: TButton;
    PrgFolderEd: TEdit;
    IconFileEd: TEdit;
    IconFileEdBt: TButton;
    IconNumEd: TEdit;
    UpDown1: TUpDown;
    Button2: TButton;
    PrgDefaultCb: TCheckBox;
    PrgFixedCb: TCheckBox;
    PrgVisibleCb: TCheckBox;
    GroupBox5: TGroupBox;
    Label10: TLabel;
    Label15: TLabel;
    PrgDependsEd: TEdit;
    PrgDependsEdBt: TButton;
    PrgExcludeEd: TEdit;
    Button4: TButton;
    GroupBox6: TGroupBox;
    Label39: TLabel;
    Label40: TLabel;
    PreRegEditBt: TButton;
    PreRegEd: TEdit;
    PostRegEditBt: TButton;
    PostRegEd: TEdit;
    Button6: TButton;
    GroupBox7: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    CommandEd2: TEdit;
    CommandEd1: TEdit;
    CommandEdBt1: TButton;
    CommandEdBt2: TButton;
    CommandEdBt3: TButton;
    CommandEdBt4: TButton;
    CommandEdBt5: TButton;
    CommandEdBt6: TButton;
    CommandEd6: TEdit;
    CommandEd5: TEdit;
    CommandEd4: TEdit;
    CommandEd3: TEdit;
    PrgRebootCb: TCheckBox;
    PrgKillWaitEd: TEdit;
    UpDown3: TUpDown;
    Button5: TButton;
    Image3: TImage;
    GroupBox8: TGroupBox;
    Label41: TLabel;
    LogMemo: TMemo;
    Label3: TLabel;
    Label42: TLabel;
    UserButtonFolderEdit1: TEdit;
    UserButtonFolderEditBt1: TButton;
    Label43: TLabel;
    UserButtonCommandEdit1: TEdit;
    UserButtonCommandEditBt1: TButton;
    Label61: TLabel;
    UserButtonPictEdit1: TEdit;
    UserButtonPictEditBt1: TButton;
    Label62: TLabel;
    UserButtonViewTextEdit1: TEdit;
    UserButtonViewTextEditBt1: TButton;
    UserButtonCaptionEdit1: TEdit;
    Label63: TLabel;
    Label64: TLabel;
    UserButtonHintEdit1: TEdit;
    GroupBox16: TGroupBox;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Button1: TButton;
    UserButtonFolderEdit2: TEdit;
    UserButtonFolderEditBt2: TButton;
    UserButtonCommandEdit2: TEdit;
    UserButtonCommandEditBt2: TButton;
    UserButtonPictEdit2: TEdit;
    UserButtonPictEditBt2: TButton;
    UserButtonViewTextEdit2: TEdit;
    UserButtonViewTextEditBt2: TButton;
    UserButtonCaptionEdit2: TEdit;
    UserButtonHintEdit2: TEdit;
    GroupBox17: TGroupBox;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Button7: TButton;
    UserButtonFolderEdit3: TEdit;
    UserButtonFolderEditBt3: TButton;
    UserButtonCommandEdit3: TEdit;
    UserButtonCommandEditBt3: TButton;
    UserButtonPictEdit3: TEdit;
    UserButtonPictEditBt3: TButton;
    UserButtonViewTextEdit3: TEdit;
    UserButtonViewTextEditBt3: TButton;
    UserButtonCaptionEdit3: TEdit;
    UserButtonHintEdit3: TEdit;
    UserButtonVisibleCb1: TCheckBox;
    UserButtonVisibleCb3: TCheckBox;
    UserButtonVisibleCb2: TCheckBox;
    Label77: TLabel;
    RootFolderEdit: TEdit;
    RootFolderEditBt: TButton;
    OpenAllDialog: TOpenDialog;
    procedure NextBtClick(Sender: TObject);
    procedure CancelBtClick(Sender: TObject);
    procedure PrevBtClick(Sender: TObject);
    procedure SelFileBtClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WizardNbPageChanged(Sender: TObject);
    procedure SelectProgTreeClick(Sender: TObject);
    procedure SelectProgTreeChange(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeCollapsed(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure SelectProgTreeContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure SelectProgTreeExpanded(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure SelectProgTreeChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure SelectProgTreeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SelectProgTreeKeyPress(Sender: TObject; var Key: Char);
    procedure GroupListBoxClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure PrgDependsEdBtClick(Sender: TObject);
    procedure GroupCb2Select(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GroupListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure GrpDelBtClick(Sender: TObject);
    procedure GrpAddBtClick(Sender: TObject);
    procedure GrpUpBtClick(Sender: TObject);
    procedure GrpDownBtClick(Sender: TObject);
    procedure PrgDeleteBtClick(Sender: TObject);
    procedure PrgAddBtClick(Sender: TObject);
    procedure PrgUpBtClick(Sender: TObject);
    procedure PrgDownBtClick(Sender: TObject);
    procedure SelectProgTreeGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeGetSelectedIndex(Sender: TObject; Node: TTreeNode);
    procedure LastProjectRbClick(Sender: TObject);
    procedure FlatGroupBoxClick(Sender: TObject);
    procedure PrRootEditBtClick(Sender: TObject);
    procedure PrTagEditBtClick(Sender: TObject);
    procedure PrIconLibEditBtClick(Sender: TObject);
    procedure PrScrShotFolderEditBtClick(Sender: TObject);
    procedure PrReadMeFileEditBtClick(Sender: TObject);
    procedure PrLicenseFileEditBtClick(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure PreInstallBeforeRegEditBtClick(Sender: TObject);
    procedure PreInstallAfterRegEditBtClick(Sender: TObject);
    procedure PreInstallCommandEdit1BtClick(Sender: TObject);
    procedure PreInstallCommandEdit2BtClick(Sender: TObject);
    procedure PreInstallCommandEdit3BtClick(Sender: TObject);
    procedure PreInstallCommandEdit4BtClick(Sender: TObject);
    procedure PostInstallFolderEditBtClick(Sender: TObject);
    procedure PostInstallBeforeRegEditBtClick(Sender: TObject);
    procedure PostInstallAfterRegEditBtClick(Sender: TObject);
    procedure PostInstallCommandEdit1BtClick(Sender: TObject);
    procedure PostInstallCommandEdit2BtClick(Sender: TObject);
    procedure PostInstallCommandEdit3BtClick(Sender: TObject);
    procedure PostInstallCommandEdit4BtClick(Sender: TObject);
    procedure UserButtonFolderEditBt1Click(Sender: TObject);
    procedure UserButtonPictEditBt1Click(Sender: TObject);
    procedure UserButtonCommandEditBt1Click(Sender: TObject);
    procedure UserButtonViewTextEditBt1Click(Sender: TObject);
    procedure UserButtonFolderEditBt2Click(Sender: TObject);
    procedure UserButtonPictEditBt2Click(Sender: TObject);
    procedure UserButtonCommandEditBt2Click(Sender: TObject);
    procedure UserButtonViewTextEditBt2Click(Sender: TObject);
    procedure UserButtonPictEditBt3Click(Sender: TObject);
    procedure UserButtonFolderEditBt3Click(Sender: TObject);
    procedure UserButtonCommandEditBt3Click(Sender: TObject);
    procedure UserButtonViewTextEditBt3Click(Sender: TObject);
    procedure IconFileEdBtClick(Sender: TObject);
    procedure PrgFolderEdBtClick(Sender: TObject);
    procedure PreRegEditBtClick(Sender: TObject);
    procedure PostRegEditBtClick(Sender: TObject);
    procedure CommandEdBt1Click(Sender: TObject);
    procedure CommandEdBt2Click(Sender: TObject);
    procedure CommandEdBt3Click(Sender: TObject);
    procedure CommandEdBt4Click(Sender: TObject);
    procedure CommandEdBt5Click(Sender: TObject);
    procedure CommandEdBt6Click(Sender: TObject);
  private
    { Private declarations }
    CurrInstallItem: PInstallItem;
    CurrInstallGroup: PInstallGroup;
    function LoadConfig(FileName:string):boolean;
    procedure LoadHeaderSection;
    procedure SaveHeaderSection;
    procedure LoadPostinstallSection;
    procedure SavePostinstallSection;
    procedure LoadInstallitem(AItem: PInstallItem);
    procedure SaveInstallItem(AItem: PInstallItem);
    procedure LoadGroup(AItem: PInstallGroup);
    procedure SaveGroup(AItem: PInstallGroup);
    procedure NodeStateChange(Node:TTreeNode);
    procedure PrepareGroupList;
    procedure PrepareProgTree;
    procedure EnablePrgBox(Enabled:boolean);
    function  ChangePage(OldPage, NewPage:integer):boolean;
    procedure GenerateReport;
  public
    { Public declarations }
  end;

var
  ConfigedFm: TConfigedFm;


implementation

uses DependsEdit;

{$R *.dfm}

 var
  ConfigName: string;
  IsNewProject: boolean = false;
  IsProjectLoadet: boolean = false;


function TConfigedFm.LoadConfig(FileName:string):boolean;
begin
  result:=false;
  if FileExists(FileName)then begin
    result:=GroupsLoadFromIni(FileName);
  end
end;

procedure TConfigedFm.PrepareProgTree;
 var
  i:integer;
begin
 FillTreeView(SelectProgTree,false,false);
 GroupCb2.Clear;
 for I := 0 to GetGroupCount - 1 do begin
   GroupCb2.AddItem(GetGroupFromId(I).Group,TObject(GetGroupFromId(I)));
 end;
 PrgScrollBox.Visible:=false;
 if GetGroupCount>0 then begin
  PrgItemEditPanel.Visible:= true;
  GroupWarningLabel.Caption:='       !'#13#10#13#10'    ""   .';
 end else begin
  PrgItemEditPanel.Visible:= false;
  GroupWarningLabel.Caption:=' ( )    !'#13#10#13#10'      !';
 end;
end;

// Programm items command

procedure TConfigedFm.PrgFolderEdBtClick(Sender: TObject);
begin
  //
end;


procedure TConfigedFm.CommandEdBt1Click(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.CommandEdBt2Click(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.CommandEdBt3Click(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.CommandEdBt4Click(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.CommandEdBt5Click(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.CommandEdBt6Click(Sender: TObject);
begin
   //
end;


//Prg item registry 

procedure TConfigedFm.PreRegEditBtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PostRegEditBtClick(Sender: TObject);
begin
  //
end;



// Postinstall control group

procedure TConfigedFm.PostInstallAfterRegEditBtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PostInstallBeforeRegEditBtClick(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.PostInstallCommandEdit1BtClick(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.PostInstallCommandEdit2BtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PostInstallCommandEdit3BtClick(Sender: TObject);
begin
   //
end;

procedure TConfigedFm.PostInstallCommandEdit4BtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PostInstallFolderEditBtClick(Sender: TObject);
begin
  //
end;


// Preinstall control group

procedure TConfigedFm.PreInstallAfterRegEditBtClick(Sender: TObject);
begin
//
end;

procedure TConfigedFm.PreInstallBeforeRegEditBtClick(Sender: TObject);
begin
//
end;

procedure TConfigedFm.PreInstallCommandEdit1BtClick(Sender: TObject);
begin
//
end;

procedure TConfigedFm.PreInstallCommandEdit2BtClick(Sender: TObject);
begin
//
end;

procedure TConfigedFm.PreInstallCommandEdit3BtClick(Sender: TObject);
begin
//
end;

procedure TConfigedFm.PreInstallCommandEdit4BtClick(Sender: TObject);
begin
//
end;


procedure TConfigedFm.PrepareGroupList;
 var
  i:integer;
begin
  GroupListBox.Clear;
  for I := 0 to GetGroupCount - 1 do begin
     GroupListBox.AddItem(GetGroupFromId(I).Group,TObject(GetGroupFromId(I)));
  end;
  if GroupListBox.Count > 0 then GroupListBox.ItemIndex:=0;
  GroupListBoxClick(nil);
end;


procedure TConfigedFm.LoadHeaderSection;
begin
 PrVersionEdit.Text:=SetVer;
 PrTimeEd.Text:=SetDate;
 PrAutorEdit.Text:=SetAutor;
 PrDeskrEdit.Text:=SetDescription;

 PrRootEdit.Text:=RootInstallDir;
 PrTagEdit.Text:=SourceTagFile;
 PrFddDriveCb.Checked:=CheckFDD;
 PrFlashDriveCb.Checked:=CheckFlash;
 PrHddDriveCb.Checked:=CheckHDD;
 PrLanDriveCb.Checked:=CheckNet;
 PrCDdriveCb.Checked:=CheckCd;
 PrLogEnableCb.Checked:=LogInstall;
 PrLogDetalizeCb.Checked:=DetaliseLog;
 PrLogEdit.Text:=LogFile;
 PrRunOnceEdit.Text:=RunOnceSubKey;
 PrRunEdit.Text:=RunValyeName;
 PrRunOnceEditRb.Checked:=Not  UseRunKey;
 PrRunEditRb.Checked:=UseRunKey;

 PrIconLibEdit.Text:=CommonIconLib;
 PrScrShotFolderEdit.Text:=CommonShotFolder;
 PrReadMeFileEdit.Text:=ReadMeTxt;
 PrLicenseFileEdit.Text:=LicenseTxt;
 PrAdminRightCb.Checked:=AdminRightsRequired;
 PrWelcomPageCb.Checked:=EnableWelcomeDlg;
 PrCloseMsgCb.Checked:=EnableCloseMsg;
 PrAutocloseCb.Checked:=AutoClose;
 PrShowLogCb.Checked:=ShowLog;
 PrBlockUserInputCb.Checked:=EnableUserInput;
 PrWaitTimerEdit.Text:=IntToStr(StartTimerTime);
end;

procedure TConfigedFm.SaveHeaderSection;
begin
 //SetVer:=PrVersionEdit.Text;
 SetDate:=PrTimeEd.Text;
 SetAutor:=PrAutorEdit.Text;
 SetDescription:=PrDeskrEdit.Text;

 RootInstallDir:=PrRootEdit.Text;
 SourceTagFile:=PrTagEdit.Text;
 CheckFDD:=PrFddDriveCb.Checked;
 CheckFlash:=PrFlashDriveCb.Checked;
 CheckHDD:=PrHddDriveCb.Checked;
 CheckNet:=PrLanDriveCb.Checked;
 CheckCd:=PrCDdriveCb.Checked;
 LogInstall:=PrLogEnableCb.Checked;
 DetaliseLog:=PrLogDetalizeCb.Checked;
 LogFile:=PrLogEdit.Text;
 RunOnceSubKey:=PrRunOnceEdit.Text;
 RunValyeName:=PrRunEdit.Text;
 UseRunKey:=Not PrRunOnceEditRb.Checked ;
 UseRunKey:=PrRunEditRb.Checked;

 CommonIconLib:=PrIconLibEdit.Text;
 CommonShotFolder:=PrScrShotFolderEdit.Text;
 ReadMeTxt:=PrReadMeFileEdit.Text;
 LicenseTxt:=PrLicenseFileEdit.Text;
 AdminRightsRequired:=PrAdminRightCb.Checked;
 EnableWelcomeDlg:=PrWelcomPageCb.Checked;
 EnableCloseMsg:=PrCloseMsgCb.Checked;
 AutoClose:=PrAutocloseCb.Checked;
 ShowLog:=PrShowLogCb.Checked;
 EnableUserInput:=PrBlockUserInputCb.Checked;
 StartTimerTime:=StrToIntDef(PrWaitTimerEdit.Text,0);
end;

procedure TConfigedFm.LoadPostinstallSection;
begin
 PreInstallFolderEdit.Text:= PreInstallFolder;
 PreInstallBeforeRegEdit.Text:= BeforePreRegFile;
 PreInstallAfterRegEdit.Text:= BeforePostRegFile;
 PreInstallCommandEdit1.Text:= PreCommand[0];
 PreInstallCommandEdit2.Text:= PreCommand[1];
 PreInstallCommandEdit3.Text:= PreCommand[2];
 PreInstallCommandEdit4.Text:= PreCommand[3];

 PostInstallFolderEdit.Text:= PostInstallFolder;
 PostInstallBeforeRegEdit.Text:= AfterPreRegFile;
 PostInstallAfterRegEdit.Text:= AfterPostRegFile;
 PostInstallCommandEdit1.Text:= PostCommand[0];
 PostInstallCommandEdit2.Text:= PostCommand[1];
 PostInstallCommandEdit3.Text:= PostCommand[2];
 PostInstallCommandEdit4.Text:= PostCommand[3];

 CloseProgRb.Checked:= true;
 RebootRb.Checked:= RebootFlag;
 PowerOffBt.Checked:= PowerOffFlag;

 UserButtonCaptionEdit1.Text:= UserButton[1].Caption;
 UserButtonHintEdit1.Text:= UserButton[1].Hint;
 UserButtonPictEdit1.Text:= UserButton[1].Picture;
 UserButtonFolderEdit1.Text:= UserButton[1].Folder;
 UserButtonCommandEdit1.Text:= UserButton[1].Command;
 UserButtonViewTextEdit1.Text:= UserButton[1].Text;
 UserButtonVisibleCb1.Checked:= UserButton[1].Visible;

 UserButtonCaptionEdit2.Text:= UserButton[2].Caption;
 UserButtonHintEdit2.Text:= UserButton[2].Hint;
 UserButtonPictEdit2.Text:= UserButton[2].Picture;
 UserButtonFolderEdit2.Text:= UserButton[2].Folder;
 UserButtonCommandEdit2.Text:= UserButton[2].Command;
 UserButtonViewTextEdit2.Text:= UserButton[2].Text;
 UserButtonVisibleCb2.Checked:= UserButton[2].Visible;

 UserButtonCaptionEdit3.Text:= UserButton[3].Caption;
 UserButtonHintEdit3.Text:= UserButton[3].Hint;
 UserButtonPictEdit3.Text:= UserButton[3].Picture;
 UserButtonFolderEdit3.Text:= UserButton[3].Folder;
 UserButtonCommandEdit3.Text:= UserButton[3].Command;
 UserButtonViewTextEdit3.Text:= UserButton[3].Text;
 UserButtonVisibleCb3.Checked:= UserButton[3].Visible;

end;

procedure TConfigedFm.SavePostinstallSection;
begin
PreInstallFolder:= PreInstallFolderEdit.Text;
BeforePreRegFile:= PreInstallBeforeRegEdit.Text;
BeforePostRegFile:= PreInstallAfterRegEdit.Text;
PreCommand[0]:= PreInstallCommandEdit1.Text;
PreCommand[1]:= PreInstallCommandEdit2.Text;
PreCommand[2]:= PreInstallCommandEdit3.Text;
PreCommand[3]:= PreInstallCommandEdit4.Text;

 PostInstallFolder:= PostInstallFolderEdit.Text;
 AfterPreRegFile:=PostInstallBeforeRegEdit.Text;
 AfterPostRegFile:= PostInstallAfterRegEdit.Text;
 PostCommand[0]:= PostInstallCommandEdit1.Text;
 PostCommand[1]:= PostInstallCommandEdit2.Text;
 PostCommand[2]:= PostInstallCommandEdit3.Text;
 PostCommand[3]:= PostInstallCommandEdit4.Text;


 RebootFlag:= RebootRb.Checked;
 PowerOffFlag:= PowerOffBt.Checked;

 UserButton[1].Caption := UserButtonCaptionEdit1.Text;
 UserButton[1].Hint := UserButtonHintEdit1.Text;
 UserButton[1].Picture := UserButtonPictEdit1.Text;
 UserButton[1].Folder := UserButtonFolderEdit1.Text;
 UserButton[1].Command := UserButtonCommandEdit1.Text;
 UserButton[1].Text := UserButtonViewTextEdit1.Text;
 UserButton[1].Visible := UserButtonVisibleCb1.Checked;

 UserButton[2].Caption := UserButtonCaptionEdit2.Text;
 UserButton[2].Hint := UserButtonHintEdit2.Text;
 UserButton[2].Picture := UserButtonPictEdit2.Text;
 UserButton[2].Folder := UserButtonFolderEdit2.Text;
 UserButton[2].Command := UserButtonCommandEdit2.Text;
 UserButton[2].Text := UserButtonViewTextEdit2.Text;
 UserButton[2].Visible := UserButtonVisibleCb2.Checked;

 UserButton[3].Caption := UserButtonCaptionEdit3.Text;
 UserButton[3].Hint := UserButtonHintEdit3.Text;
 UserButton[3].Picture := UserButtonPictEdit3.Text;
 UserButton[3].Folder := UserButtonFolderEdit3.Text;
 UserButton[3].Command := UserButtonCommandEdit3.Text;
 UserButton[3].Text := UserButtonViewTextEdit3.Text;
 UserButton[3].Visible := UserButtonVisibleCb3.Checked;

end;

procedure TConfigedFm.LoadInstallitem(AItem: PInstallItem);
begin
  if AItem =nil then exit;  
  GroupCb2.ItemIndex:=GroupCb2.Items.IndexOfObject(TObject(AItem^.Parent));
  PrgNameEd.Text:= AItem^.Caption;
  PrgDiskrEd.Text:=AItem^.Description;
  PrgFolderEd.Text:=AItem^.Folder;
  IconFileEd.Text:=AItem^.IconFileName;
  IconNumEd.Text:=IntToStr(AItem^.IconNumber);
  CommandEd1.Text:=AItem^.Command1;
  CommandEd2.Text:=AItem^.Command2;
  CommandEd3.Text:=AItem^.Command3;
  CommandEd4.Text:=AItem^.Command4;
  CommandEd5.Text:=AItem^.Command5;
  CommandEd6.Text:=AItem^.Command6;
  PrgKillWaitEd.Text:=IntTostr(AItem^.KillWait);
  PrgRebootCb.Checked:=AItem^.RebootNeed;
  PreRegEd.Text:=AItem^.PreRegFile;
  PostRegEd.Text:=AItem^.PostRegFile;
  PrgDefaultCb.Checked:=boolean(AItem^.SelectDefault);
  PrgFixedCb.Checked:=AItem^.Fixed;
  PrgVisibleCb.Checked:=not AItem^.Visible;
  PrgDependsEd.Text:= GetDependsString(AItem);
  PrgExcludeEd.Text:= GetExcludeString(AItem);
end;

procedure TConfigedFm.SaveInstallItem(AItem: PInstallItem);
var
   TmpGroup:PInstallGroup;
   R:Trect;
begin
  if AItem =nil then exit;
  if AItem^.Parent <> PInstallGroup(GroupCb2.Items.Objects[GroupCb2.ItemIndex]) then begin
      AItem^.Parent.ItemList.Remove(AItem);
      TmpGroup:=GetGroupFromId(GroupCb2.ItemIndex);
      TmpGroup.ItemList.Add(AItem);
      AItem^.Parent:=TmpGroup;
      AItem^.Group:=TmpGroup^.Group;
      AItem^.INode.MoveTo(TmpGroup^.INode,naAddChildFirst);
      AItem^.INode.StateIndex:=1;
  end;
  AItem^.Caption:=PrgNameEd.Text;
  AItem^.INode.SelectedIndex:=AItem^.ImageId;
  AItem^.INode.ImageIndex:=AItem^.ImageId;
  AItem^.INode.StateIndex:=-1;
  AItem^.INode.StateIndex:=1+Ord(AItem^.SelectDefault);


  AItem^.INode.Text:= AItem^.Caption;
  AItem^.Description:=PrgDiskrEd.Text;
  AItem^.Folder:=PrgFolderEd.Text;
  AItem^.IconFileName:=IconFileEd.Text;
  AItem^.IconNumber:=StrToIntDef(IconNumEd.Text,0);
  AItem^.Command1:=CommandEd1.Text;
  AItem^.Command2:=CommandEd2.Text;
  AItem^.Command3:=CommandEd3.Text;
  AItem^.Command4:=CommandEd4.Text;
  AItem^.Command5:=CommandEd5.Text;
  AItem^.Command6:=CommandEd6.Text;
  AItem^.KillWait:=StrToIntDef(PrgKillWaitEd.Text,0);
  AItem^.RebootNeed:=PrgRebootCb.Checked;
  AItem^.PreRegFile:=PreRegEd.Text;
  AItem^.PostRegFile:=PostRegEd.Text;
  AItem^.SelectDefault:=PrgDefaultCb.Checked;
  AItem^.Fixed:=PrgFixedCb.Checked;
  AItem^.Visible:=not PrgVisibleCb.Checked;
  R := AItem^.INode.DisplayRect(False);
  InvalidateRect(SelectProgTree.Handle, @R, True);
  SelectProgTree.Update;

  //NodeStateChange(AItem^.INode);
end;

procedure TConfigedFm.LoadGroup(AItem: PInstallGroup);
begin
 if AItem <> nil then begin
    NameGroupEd.Text:= AItem^.Group;
    DescrGroupEd.Text:= AItem^.Description;
    NormGroupRb.Checked:=true;
    ExpandGroupRb.Checked:= AItem^.Expandet;
    BlockedGroupRb.Checked:= AItem^.Blocked;
 end;
end;

procedure TConfigedFm.SaveGroup(AItem: PInstallGroup);
var
 R:Trect;
 Id:integer;
begin
  if AItem <> nil then begin
     AItem^.Group:= NameGroupEd.Text;
     AItem^.Description:= DescrGroupEd.Text;
     AItem^.Expandet:= ExpandGroupRb.Checked;
     AItem^.Blocked:= BlockedGroupRb.Checked;
     Id:= GroupListBox.Items.IndexOfObject(TObject(AItem));
     if Id > -1 then  begin
      R := GroupListBox.ItemRect(Id);
      InvalidateRect(GroupListBox.Handle, @R, True);
     end;
  end;
end;

procedure TConfigedFm.GenerateReport;
begin
 LogMemo.Clear;
 with LogMemo.Lines do begin
  Add(': ' + ConfigName);
  Add('');
  Add(' : '+ SetVer);
  Add(' : '+ SetDate);
  Add(': '+ SetAutor);
  Add(': '+ SetDescription);
  Add('');
  Add(' : '+ IntToStr(GetGroupCount));
  Add(' : '+ IntToStr(GetAllItemCount));
 end;
end;

procedure TConfigedFm.PrgUpBtClick(Sender: TObject);
var
 ParentNode,CurrNode,PrevNode:TTreeNode;
 ParentGroup:PInstallGroup;
 OldId,NewId:integer;
 NewItem:PInstallItem;
 R:TRect;
begin
 if (SelectProgTree.Selected <> nil) and
    (SelectProgTree.Selected.Level > 0) then begin
       CurrNode:=SelectProgTree.Selected;
       PrevNode:=CurrNode.getPrevSibling;
       if PrevNode = nil then exit;
       ParentNode:=CurrNode.Parent;
       if ParentNode = nil then exit;
       ParentGroup:= PInstallGroup(ParentNode.Data);
       OldId:= ParentGroup.ItemList.IndexOf(PInstallItem(CurrNode.Data));
       CurrNode.MoveTo(PrevNode,naInsert);
       NewId:= ParentNode.IndexOf(CurrNode);
       R :=CurrNode.DisplayRect(False);
       InvalidateRect(SelectProgTree.Handle, @R, True);
       ParentGroup.ItemList.Move(OldId,NewId);
 end;
end;

procedure TConfigedFm.PrIconLibEditBtClick(Sender: TObject);
begin
  OpenAllDialog.Title:='  ';
  OpenAllDialog.FileName:=PrIconLibEdit.Text;
  if OpenAllDialog.Execute(self.Handle) then PrIconLibEdit.Text:= OpenAllDialog.FileName;
end;

procedure TConfigedFm.PrLicenseFileEditBtClick(Sender: TObject);
begin
  OpenAllDialog.Title:='  ';
  OpenAllDialog.FileName:=PrLicenseFileEdit.Text;
  if OpenAllDialog.Execute(self.Handle) then PrLicenseFileEdit.Text:= OpenAllDialog.FileName;
end;

procedure TConfigedFm.PrReadMeFileEditBtClick(Sender: TObject);
begin
  OpenAllDialog.Title:='  ReadMe';
  OpenAllDialog.FileName:=PrReadMeFileEdit.Text;
  if OpenAllDialog.Execute(self.Handle) then PrReadMeFileEdit.Text:= OpenAllDialog.FileName;
end;

procedure TConfigedFm.PrRootEditBtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PrScrShotFolderEditBtClick(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.PrTagEditBtClick(Sender: TObject);
begin
  OpenAllDialog.Title:='  ';
  OpenAllDialog.FileName:=PrTagEdit.Text;
  if OpenAllDialog.Execute(self.Handle) then PrTagEdit.Text:= ExtractFileName(OpenAllDialog.FileName);
end;

procedure TConfigedFm.PrgDownBtClick(Sender: TObject);
var
 ParentNode,CurrNode,PrevNode:TTreeNode;
 ParentGroup:PInstallGroup;
 OldId,NewId:integer;
 NewItem:PInstallItem;
 R:TRect;
begin
 if (SelectProgTree.Selected <> nil) and
    (SelectProgTree.Selected.Level > 0) then begin
       CurrNode:=SelectProgTree.Selected;
       PrevNode:=CurrNode.getNextSibling;
       if PrevNode = nil then exit;
       ParentNode:=CurrNode.Parent;
       if ParentNode = nil then exit;
       ParentGroup:= PInstallGroup(ParentNode.Data);
       OldId:= ParentGroup.ItemList.IndexOf(PInstallItem(CurrNode.Data));
       //CurrNode.MoveTo(CurrNode,naAdd);
       CurrNode.MoveTo(PrevNode,naAdd);
       NewId:= ParentNode.IndexOf(CurrNode);
       R := CurrNode.DisplayRect(False);
       InvalidateRect(SelectProgTree.Handle, @R, True);
       ParentGroup.ItemList.Move(OldId,NewId);
 end;
end;



procedure TConfigedFm.PrgDeleteBtClick(Sender: TObject);
 var
  TmpItem:PInstallItem;
begin
 if (SelectProgTree.Selected <> nil) and
    (SelectProgTree.Selected.Level > 0) then begin
      TmpItem:=PInstallItem(SelectProgTree.Selected.Data);
      TmpItem^.INode.Delete;
      InstallItemDelete(TmpItem);
 end;
end;

procedure TConfigedFm.PrgAddBtClick(Sender: TObject);
var
 ParentNode,ChildNode:TTreeNode;
 ParentGroup:PInstallGroup;
 NewItem:PInstallItem;
begin
 if (SelectProgTree.Selected <> nil) then begin
    if SelectProgTree.Selected.Level > 0 then
      ParentNode:= SelectProgTree.Selected.Parent
    else  ParentNode:= SelectProgTree.Selected;
 end else ParentNode:= SelectProgTree.Items[0];
 ParentGroup:=PInstallGroup(ParentNode.Data);
 NewItem:=NewInstallItem(ParentGroup);
 NewItem^.Caption:=GetNewInstallItemName(ParentGroup);
 NewItem^.Description:=NewInstallItemDescr;
 NewItem^.Number:= GetNewInstallItemNumber;
 InstallItemAdd(ParentGroup,NewItem);
 ChildNode:=SelectProgTree.Items.AddChildObject(ParentNode,NewItem^.Caption,NewItem);
 ChildNode.SelectedIndex:=NewItem^.ImageId;
 ChildNode.ImageIndex:=NewItem^.ImageId;
 ChildNode.StateIndex:=1+Ord(NewItem^.Selected);
 if NewItem^.Fixed then ChildNode.StateIndex:=ChildNode.StateIndex+3;
 NewItem^.INode:=ChildNode;
 SelectProgTree.Selected:=ChildNode;
end;

procedure TConfigedFm.Button14Click(Sender: TObject);
begin
//
end;

procedure TConfigedFm.Button1Click(Sender: TObject);
begin
 if TButton(Sender).Caption = '-' then begin
    TButton(Sender).Caption := '+';
    TButton(Sender).Parent.Height:= TButton(Sender).Height+6;
 end else begin
   TButton(Sender).Caption := '-';
   TButton(Sender).Parent.Height:= TButton(Sender).Tag
 end;
 TButton(Sender).Top:=0;
 TButton(Sender).Left:=TButton(Sender).Parent.Width - TButton(Sender).Width;
end;

procedure TConfigedFm.CancelBtClick(Sender: TObject);
begin
 close;
end;

procedure TConfigedFm.FormCreate(Sender: TObject);
begin
   CreateInstallList;
   GetSelfFolder;
   WizardNb.PageIndex:=0;
   PostParamScrollBox.ScrollInView(GroupBox2);
   HeaderScrollBox.ScrollInView(GroupBox10);
   SmallIconList:=SelectTreeImg;
   IconBackColor:= SelectProgTree.Color;
   IsEditorMode:=true;
end;

procedure TConfigedFm.FlatGroupBoxClick(Sender: TObject);
begin
 TScrollBox(TGroupBox(Sender).Parent).ScrollInView(TGroupBox(Sender));
end;

procedure TConfigedFm.GroupCb2Select(Sender: TObject);
begin
  if CurrInstallItem <> nil then SaveInstallItem(CurrInstallItem);
end;

procedure TConfigedFm.GroupListBoxClick(Sender: TObject);
begin
   if GroupListBox.ItemIndex > -1 then  begin
     SaveGroup(CurrInstallGroup);
     CurrInstallGroup:=PInstallGroup(GroupListBox.Items.Objects[GroupListBox.ItemIndex]);
     LoadGroup(CurrInstallGroup);
   end;
end;

procedure TConfigedFm.GroupListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
 var
  Flags: Longint;
  Data:string;
  TmpGroup:PInstallGroup;
  Id:integer;
begin
  Flags := DrawTextBiDiModeFlags(DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
  GroupListBox.Canvas.FillRect(Rect);
  TmpGroup:= PInstallGroup(GroupListBox.Items.Objects[Index]);
  if TmpGroup <> nil then begin
     if TmpGroup^.Blocked then Id:=2
        else if TmpGroup^.Expandet then Id:=1
                else Id:=0;
     SelectTreeImg.Draw(GroupListBox.Canvas,Rect.left+2,Rect.Top+(Rect.Bottom - Rect.Top - SelectTreeImg.Height) div 2,Id);
     Inc(Rect.Left, 2+SelectTreeImg.Width+2);
     Data := TmpGroup^.Group; //GroupListBox.Items[Index];
     DrawText(GroupListBox.Canvas.Handle, PChar(Data), Length(Data), Rect, Flags);
  end;
end;

procedure TConfigedFm.GrpAddBtClick(Sender: TObject);
var
 NewGroup:PInstallGroup;
begin
  SaveGroup(CurrInstallGroup);
  NewGroup:=NewInstallGroup(GetNewInstallGroupName, NewGroupDescr);
  GroupListBox.AddItem(NewGroup^.Group,TObject(NewGroup));
  GroupListBox.ItemIndex:=GroupListBox.Count-1;
  GroupListBoxClick(nil);
end;

procedure TConfigedFm.GrpDelBtClick(Sender: TObject);
var
 NewGroup:PInstallGroup;
 Id:integer;
begin
  Id:= GroupListBox.ItemIndex;
  if Id > -1 then  begin
     SaveGroup(CurrInstallGroup);
     CurrInstallGroup:=nil;
     NewGroup:=PInstallGroup(GroupListBox.Items.Objects[Id]);
     DeleteInstallGroup(NewGroup);
     GroupListBox.Items.Delete(Id);
     dec(Id);
     if Id < 0 then Id:=0 else if Id > GroupListBox.Count-1 then Id:=GroupListBox.Count-1;
     GroupListBox.ItemIndex:=Id;
     GroupListBoxClick(nil);
  end;
end;

procedure TConfigedFm.GrpDownBtClick(Sender: TObject);
var
 Id:integer;
begin
 Id:= GroupListBox.ItemIndex;
 if Id = GroupListBox.Count-1 then exit;
   GroupListBox.Items.Exchange(Id, Id+1);
   GroupList.Exchange(Id, Id+1);
end;

procedure TConfigedFm.GrpUpBtClick(Sender: TObject);
var
 Id:integer;
begin
 Id:= GroupListBox.ItemIndex;
 if Id=0 then exit;
 GroupListBox.Items.Exchange(Id, Id-1);
 GroupList.Exchange(Id, Id-1);
end;

procedure TConfigedFm.IconFileEdBtClick(Sender: TObject);
begin
 //
end;

procedure TConfigedFm.NextBtClick(Sender: TObject);
 var
  OldPg,NewPg:integer;
begin
  OldPg:=WizardNb.PageIndex;
  NewPg:=WizardNb.PageIndex+1;
  if ChangePage(OldPg,NewPg) then begin
     PrevBt.Enabled:=true;
     WizardNb.PageIndex:= NewPg;
     //NextBt.Enabled:= WizardNb.PageIndex+1 < WizardNb.Pages.Count;
  end;
end;

procedure TConfigedFm.PrevBtClick(Sender: TObject);
 var
  OldPg,NewPg:integer;
begin
  OldPg:=WizardNb.PageIndex;
  NewPg:=WizardNb.PageIndex-1;
  if ChangePage(OldPg,NewPg) then begin
    NextBt.Enabled:=true;
    WizardNb.PageIndex:= NewPg;
    PrevBt.Enabled:= NewPg>0;
  end;
end;

procedure TConfigedFm.PrgDependsEdBtClick(Sender: TObject);
var
 i,J:integer;
 TempGroup:PInstallGroup;
 TempItem: PInstallItem;
begin
  with TDependsFm.Create(self) do
   try
     for i:=0 to GetGroupCount -1 do begin
       TempGroup:=GetGroupFromId(I);
       for J := 0 to TempGroup^.ItemList.Count - 1 do
         AllPrgListBox.AddItem(PInstallItem(TempGroup^.ItemList[J])^.Caption,TObject(PInstallItem(TempGroup^.ItemList[J])^.Number));
     end;
     if CurrInstallItem <> nil then begin
       for I := 0 to CurrInstallItem^.DependsList.Count - 1 do begin
         TempItem:=ItemFromNumber(Integer(CurrInstallItem^.DependsList[i]));
         if TempItem <> nil then  begin
            DependsPrgListBox.AddItem(TempItem^.Caption,TObject(TempItem^.Number));
            AllPrgListBox.Items.Delete(AllPrgListBox.Items.IndexOfObject(TObject(TempItem^.Number)));
         end;
       end;
       for I := 0 to CurrInstallItem^.ExcludeList.Count - 1 do begin
         TempItem:=ItemFromNumber(Integer(CurrInstallItem^.ExcludeList[i]));
         if TempItem <> nil then begin
          ExcludePrgListBox.AddItem(TempItem^.Caption,TObject(TempItem^.Number));
          AllPrgListBox.Items.Delete(AllPrgListBox.Items.IndexOfObject(TObject(TempItem^.Number))+1000);
         end;
       end;
     end;
   if ShowModal = mrOk then begin
     if CurrInstallItem <> nil then begin
        CurrInstallItem^.DependsList.Clear;
        for i:= 0 to DependsPrgListBox.Count - 1 do
          CurrInstallItem^.DependsList.Add(DependsPrgListBox.Items.Objects[i]);
        CurrInstallItem^.ExcludeList.Clear;
        for i:= 0 to ExcludePrgListBox.Count - 1 do
          CurrInstallItem^.ExcludeList.Add(ExcludePrgListBox.Items.Objects[i]);
     end;
     PrgDependsEd.Text:= GetDependsString(CurrInstallItem);
     PrgExcludeEd.Text:= GetExcludeString(CurrInstallItem);
   end;
  finally
     Free;
  end;
end;

procedure TConfigedFm.LastProjectRbClick(Sender: TObject);
begin
  Label2.Enabled:= not LastProjectRb.Checked;
  FileNameEdit.Enabled:=not LastProjectRb.Checked;
  SelFileBt.Enabled:=not LastProjectRb.Checked;
end;

procedure TConfigedFm.Button8Click(Sender: TObject);
begin
  PrTimeEd.Text:=DateToStr(Now);
end;

procedure TConfigedFm.EnablePrgBox(Enabled:boolean);
var
 i:integer;
begin
  for I:=0 to PrgBox.ControlCount - 1 do PrgBox.Controls[i].Enabled:= Enabled;
end;


procedure TConfigedFm.NodeStateChange(Node:TTreeNode);
var
  ParentNode: TTreeNode;
  I:integer;
  Intermediate: boolean;
  AStateIndex:integer;
  TempItem: PInstallItem;

  function SetSelection(ANode: TTreeNode; AIndex: integer):boolean;
   var
     TempState:boolean;
     ChangeState:boolean;
  begin
  result:=true;
  ChangeState:=true;
  if (ANode.Level = 1) and
     (ANode.Data <> nil)  then begin
       if Boolean(PInstallItem(ANode.Data).SelectDefault) then  AIndex:=2
                                                           else  AIndex:=1;
       if PInstallItem(ANode.Data)^.Fixed then AIndex:= AIndex+3 ;
      end
   else;
   ANode.StateIndex:=AIndex;
  end;

begin
 if (Node<> nil) then begin
    //if (Node.StateIndex = 1) then AStateIndex:=2
    //                         else
    AStateIndex:=1;
    if (Node.Level = 1) and
       (Node.Data <> nil) then begin
        TempItem:= PInstallItem(Node.Data);
        Node.Text:=TempItem.Caption;

    end;
   exit;
    if SetSelection(Node, AStateIndex) then begin
     {if Node.Count > 0 then
    { begin
        Intermediate:=false;
        for i:=Node.Count-1  downto 0 do SetSelection(Node.Item[I], AStateIndex);
        for i:=0 to Node.Count-1 do begin
         if AStateIndex <> Node.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(Node, 3);}
     end;
     
    { ParentNode:=Node.Parent;
     if ParentNode <> nil then begin
       Intermediate:=false;
       AStateIndex:= ParentNode.Item[0].StateIndex ;
       for i:=0 to ParentNode.Count-1 do begin
         if AStateIndex <> ParentNode.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(ParentNode, 3)
                       else SetSelection(ParentNode, AStateIndex); 
     end;}
  //end;
   //FastSelect.ItemIndex:=3;
   //SellMemo.Text:= SafeFormat(ConfigAllSelectCaption +#13#10+ ConfigGroupSelectCaption + #13#10,[GetAllSelectCount, GetAllItemCount,GetSelGroupCount, GetUsedGroupCount]);
 end;
end;

procedure TConfigedFm.SelectProgTreeChange(Sender: TObject; Node: TTreeNode);
 var
  NewHint:string;
  Temp:string;
  TmpGroup:PInstallGroup;
begin
   NewHint:='';
   TmpGroup:=nil;
   if Node = nil then exit;
   
   if (Node.Level = 1) and
      (Node.Data <> nil) then begin
                                CurrInstallItem:=PInstallItem(Node.Data);
                                NewHint:=CurrInstallItem^.Description;
                                TmpGroup:=CurrInstallItem^.Parent;
                                if GlobalExtendInfo then begin
                                  if CurrInstallItem^.Fixed then NewHint:= NewHint+#13#10 + HintNoChangeSelect;
                                  if CurrInstallItem^.RebootNeed then NewHint:= NewHint+#13#10+HintNeedReboot;
                                  Temp:=GetExcludeString(CurrInstallItem);
                                  if Temp<> '' then  NewHint:= NewHint+#13#10+Temp;
                                  Temp:=GetDependsString(CurrInstallItem);
                                  if Temp<> '' then  NewHint:= NewHint+#13#10+Temp;
                                end;
                                LoadInstallitem(CurrInstallItem);
                              end
   else
   if (Node.Level = 0) and
      (Node.Data <> nil) then begin
        CurrInstallItem:=nil;
        NewHint:=PInstallGroup(Node.Data).Description;
        TmpGroup:=PInstallGroup(Node.Data);
        GroupCb2.ItemIndex:=0;
       end
   else
 NewHint:='';
 PrgScrollBox.Visible:= Node.Level = 1;
 PrgScrollBox.ScrollInView(GroupBox4);
end;

procedure TConfigedFm.SelectProgTreeChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
  if CurrInstallItem<> nil then SaveInstallItem(CurrInstallItem);
end;

procedure TConfigedFm.SelectProgTreeClick(Sender: TObject);
var
  Node: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 Node:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 {if (Node<> nil) and
    (htOnStateIcon in HT) then NodeStateChange(Node);}
end;

procedure TConfigedFm.SelectProgTreeCollapsed(Sender: TObject; Node: TTreeNode);
begin
   if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=0;
   Node.SelectedIndex:=0;
  end
end;

procedure TConfigedFm.SelectProgTreeCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
  Prevent:boolean;
begin
 GetCursorPos(P);
 Prevent:=false;
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) then begin
   Prevent:=PInstallGroup(Node.Data)^.Blocked;
 end;
 AllowCollapse:= not( ((ANode<> nil) and (htOnStateIcon in HT)) or Prevent);
end;

procedure TConfigedFm.SelectProgTreeContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  //
end;

procedure TConfigedFm.SelectProgTreeExpanded(Sender: TObject; Node: TTreeNode);
begin
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=1;
   Node.SelectedIndex:=1;
  end
end;

procedure TConfigedFm.SelectProgTreeExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 AllowExpansion:= not( (ANode<> nil) and (htOnStateIcon in HT) );
end;

procedure TConfigedFm.SelectProgTreeGetImageIndex(Sender: TObject;
  Node: TTreeNode);
begin
   if Node.Level = 0 then begin
   end else begin
     Node.SelectedIndex:=PInstallitem(Node.Data)^.ImageId;
     Node.StateIndex:=-1;
     Node.StateIndex:=1+Ord(PInstallitem(Node.Data)^.SelectDefault);
   end;
end;

procedure TConfigedFm.SelectProgTreeGetSelectedIndex(Sender: TObject;
  Node: TTreeNode);
begin
   if Node.Level = 0 then begin
   end else begin
     Node.SelectedIndex:=PInstallitem(Node.Data)^.ImageId;
     Node.StateIndex:=-1;
     Node.StateIndex:=1+Ord(PInstallitem(Node.Data)^.SelectDefault);
   end;
end;

procedure TConfigedFm.SelectProgTreeKeyPress(Sender: TObject; var Key: Char);
begin
//
end;

procedure TConfigedFm.SelectProgTreeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  //
end;

procedure TConfigedFm.SelFileBtClick(Sender: TObject);
begin
 if NewProjectRb.Checked then begin
   SaveIniDialog.FileName:= FileNameEdit.Text;
   if SaveIniDialog.Execute then begin
      FileNameEdit.Text:= SaveIniDialog.FileName;
      RootFolderEdit.Text:= ExtractFileDir(SaveIniDialog.FileName);
   end;
 end else begin
   OpenIniDialog.FileName:= FileNameEdit.Text;
   if OpenIniDialog.Execute then begin
      FileNameEdit.Text:= OpenIniDialog.FileName;
      RootFolderEdit.Text:= ExtractFileDir(OpenIniDialog.FileName);
   end;
 end;
end;


procedure TConfigedFm.UserButtonCommandEditBt1Click(Sender: TObject);
begin
 //
end;

procedure TConfigedFm.UserButtonFolderEditBt1Click(Sender: TObject);
begin
 //
end;

procedure TConfigedFm.UserButtonPictEditBt1Click(Sender: TObject);
begin
//
end;

procedure TConfigedFm.UserButtonViewTextEditBt1Click(Sender: TObject);
begin
 //
end;


procedure TConfigedFm.UserButtonCommandEditBt2Click(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.UserButtonFolderEditBt2Click(Sender: TObject);
begin
 //
end;

procedure TConfigedFm.UserButtonPictEditBt2Click(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.UserButtonViewTextEditBt2Click(Sender: TObject);
begin
 //
end;


procedure TConfigedFm.UserButtonCommandEditBt3Click(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.UserButtonFolderEditBt3Click(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.UserButtonPictEditBt3Click(Sender: TObject);
begin
  //
end;

procedure TConfigedFm.UserButtonViewTextEditBt3Click(Sender: TObject);
begin
 //
end;

function  TConfigedFm.ChangePage(OldPage, NewPage:integer):boolean;
begin
   result:=false;
   if (OldPage = -1) and (NewPage = 0) then begin
     result:=true;
   end;
   if (OldPage = 0) and (NewPage = 1) then begin
     if not (IsProjectLoadet and
               (MessageBox(ConfigedFm.Handle,
                           PChar('  .       '#13#10#13#10'  ?'),
                           PChar(' .'),
                           MB_YESNO or
                           MB_ICONQUESTION or
                           MB_TASKMODAL) = IDNO)) then begin
       if NewProjectRb.Checked then begin
         ConfigName := FileNameEdit.Text;
         ProjectRootDir := RootFolderEdit.Text;
         ClearInstallList;
         SetDate:=DateToStr(Now);
         IsProjectLoadet:=true;
         IsProjectLoadet:=true;
       end else if LastProjectRb.Checked then begin
         ConfigName := FileNameEdit.Text;
         ProjectRootDir := RootFolderEdit.Text;
         ClearInstallList;
         IsProjectLoadet:=LoadConfig(ConfigName);
         if not IsProjectLoadet then MessageBox(ConfigedFm.Handle,
                                                PChar('  !.'#13#10',   ,'#13#10'   '),
                                                PChar('  .'),
                                                MB_OK or
                                                MB_ICONSTOP or
                                                MB_TASKMODAL)
       end else if OpenProjectRb.Checked then begin
         ConfigName := FileNameEdit.Text;
         ProjectRootDir := RootFolderEdit.Text;
         ClearInstallList;
         IsProjectLoadet:=LoadConfig(ConfigName);
         if not IsProjectLoadet then MessageBox(ConfigedFm.Handle,
                                                PChar('  !.'#13#10',   ,'#13#10'   '),
                                                PChar('  .'),
                                                MB_OK or
                                                MB_ICONSTOP or
                                                MB_TASKMODAL)
       end;
      end;
       LoadHeaderSection;
       result:=IsNewProject or IsProjectLoadet;
   end;
   if (OldPage = 1) and (NewPage = 2) then begin
       SaveHeaderSection;
       LoadPostinstallSection;
       result:=true;
   end;
   if (OldPage = 2) and (NewPage = 3) then begin
       SavePostinstallSection;
       CurrInstallGroup:=nil;
       PrepareGroupList;
       result:=true;
   end;
   if (OldPage = 3) and (NewPage = 4) then begin
       CurrInstallItem:=nil;
       SaveGroup(CurrInstallGroup);
       PrepareProgTree;
       result:=true;
   end;
   if (OldPage = 4) and (NewPage = 5) then begin
       SaveInstallItem(CurrInstallItem);
       SelectProgTree.Items.Clear;
       GenerateReport;
       result:=true;
   end;
   if (OldPage = 5) and (NewPage = 4) then begin
       CurrInstallItem:=nil;
       PrepareProgTree;
       result:=true;
   end;
   if (OldPage = 4) and (NewPage = 3) then begin
       SaveInstallItem(CurrInstallItem);
       SelectProgTree.Items.Clear;
       CurrInstallItem:=nil;
       CurrInstallGroup:=nil;
       PrepareGroupList;
       result:=true;
   end;
   if (OldPage = 3) and (NewPage = 2) then begin
       SaveGroup(CurrInstallGroup);
       CurrInstallItem:=nil;
       CurrInstallGroup:=nil;
       LoadPostinstallSection;
       result:=true;
   end;
   if (OldPage = 2) and (NewPage = 1) then begin
       SavePostinstallSection;
       LoadHeaderSection;
       result:=true;
   end;
   if (OldPage = 1) and (NewPage = 0) then begin
       SaveHeaderSection;
       result:=true;
   end;

   if (OldPage = 5) and (NewPage = 6) then begin
       if FileExists(ConfigName) then CopyFile(PChar(ConfigName),PChar(ConfigName + '.bak'),false);
       //ReNumerateItems;
       GroupsSaveToIni(ConfigName , false);
       result:=false;
      Close;
   end;

   

end;


procedure TConfigedFm.WizardNbPageChanged(Sender: TObject);

begin
  Caption:='  - ' +  WizardNb.ActivePage;
  if WizardNb.PageIndex = 5 then NextBt.Caption:= ''
                            else NextBt.Caption:= ' >';

end;



end.

UserButtonFolderEdit3.Text:=
UserButtonCommandEdit3.Text:=
UserButtonPictEdit3.Text:=
UserButtonViewTextEdit.Text:=
UserButtonCaptionEdit3.Text:=
UserButtonHintEdit3.Text:=
UserButtonVisibleCb3.Checked=

