{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }

unit GlobalConst;

interface

uses
  Graphics,Windows,CommonCtrl;

const
   SkinVer = '2.0';
   SetVer  = '2.0';

   PrgVer = '1.11b';
   TestOnly = true;
   TestMsg = '     OsZone!!!';

   DemoWaitTime = 500;

   MyHintHidePause = 5000;
   MyHintPause = 300;
   MyHintShortPause = 25;

   CommonCharSet = RUSSIAN_CHARSET;
   LangId = $0419;

   DefaultSkinIniName = 'skin.ini';
   DefaultSkinFolder = 'skin';

   StrAbsent = '[this str absent]';

   NewGroupName = ' ';
   NewGroupDescr = '  ';

   NewInstallItemName =' ';
   NewInstallItemDescr = '  ';

   TrayTip = 'B Software'#13#10'Post Installer ' +PrgVer;

   CopyRightLabelCaption = ' Boa Software 2005-2007'#13#10'Russia, Kursk';

   AboutMsg = 'B Software Post Installer '+ PrgVer+#13#10+
              ' Boa Software 2005-2007 Russia, Kursk'#13#10#13#10;

   AboutMoreMsg = 'Freeware. Is-As. No warranty!'#13#10 +
                  'For get more info, please, read readme.txt and license.txt.'#13#10#13#10 +
                  ', -.  !'#13#10 +
                  '   '#13#10 +
                  ',  readme.txt  license.txt';

   AboutCaption = 'B Software Post Installer '+ PrgVer;

{ Exit code constant }

   OK_EXIT = 0;
   CANCEL_EXIT = 1;
   WRONG_SKIN = 2;
   WRONG_INI = 3;
   WRONG_SET = 4;
   WRONG_LIC = 5;
   BREAK_INSTALL = 6;
   WRONG_RIGHTS = 7;
   NOT_LICASSEPTED = 8;



{Process Form consts}

var
    SkinFolder:String;
    SkinIni:String;

    SkinAutor: string;
    SkinDescription: string;
    SkinDate: string;

    LabelFont: string;
    BigLabelFont: string;
    MemoFont: string;
    TreeFont: string;
    HintFont: string;
    CommonFont: string;

    LabelColor: TColor;
    LabelActiveColor: TColor;
    ButtonFontColor: TColor;
    ButtonActiveFontColor: TColor;
    BigLabelColor: TColor;
    BigLabelShadowColor: TColor;
    MemoFontColor: TColor;
    MemoColor: TColor;
    TreeFontColor: TColor;
    TreeFontGroupColor: TColor;
    TreeColor: TColor;
    IconBackColor: TColor = clFuchsia;
    ProgressBackColor: TColor;
    ProgressColor: TColor;
    RebotProgressColor: TColor;

    HintColor: TColor;
    HintFontColor: TColor;

    LabelCaptions: array [0..6] of string;

    HelpTexts: array [0..6] of string;
    RestoreMiCaptionUp: string;
    RestoreMiCaptionDown: string;
    CloseBtHint: string;
    HelpBtHint: string;
    TrayBtHint: string;

    PrevBtCaption: string;
    PrevBtHint: string;
    NextBtCaption: string;
    NextBtHint: string;
    TestLabelCaption: string;

    { }
    StartupCaptionLabelCaption: string;
    StartupDeskriptionLabelNoWatCaption: string;
    StartupDeskriptionLabelWatCaption: string;
    StartupDeskriptionLabelCaption: string;
    StartupTimerCaptionCaption: string;
    StartupTimerCaptionHint: string;

    {  }
    LicenseCaptionLabelCaption: string;
    LicenseDeskriptionLabelCaption: string;
    CheckLicenseConfirmBtCaption: string;
    CheckLicenseConfirmBtHint: string;
    CheckLicenseCancelBtCaption: string;
    CheckLicenseCancelBtHint: string;
    CheckLicenseLicenseDlgMsg: string;

    {  }
    SelectorNextBtCaption: string;
    SelectorNextBtHint: string;
    SelectorCaptionLabelCaption: string;
    SelectorDeskriptionLabelCaption: string;
    CollapseBtHint: string;
    ExpandBtHint: string;
    FastSelectCaption :string;
    CheckAllBtCaption: string;
    CheckAllBtHint: string;
    CheckNoneBtCaption: string;
    CheckNoneBtHint: string;
    CheckDefBtCaption : string;
    CheckDefBtHint: string;

   {  }
    ConfirmNextBtCaption: string;
    ConfirmNextBtHint: string;
    ConfirmCaptionLabelCaption: string;
    ConfirmDeskriptionLabelCaption: string;
    RebotModeCaption :string;
    CheckRebootBtCaption: string;
    CheckRebootBtHint: string;
    CheckPoweroffBtCaption: string;
    CheckPoweroffBtHint: string;
    CheckCloseBtCaption : string;
    CheckCloseBtHint: string;
    SelectProgMemoHint: string;

    {    }
    PreInstallCaptionLabelCaption : string;
    PreInstallDeskriptionLabelCaption : string;

    {  }
    GrpLabelCaption: string;
    AllLabelCaption: string;
    ShowProgressCaptionLabelRestartCaption: string;
    ShowProgressCaptionLabelCaption : string;
    ScipBtCaption: string;
    ScipBtHint: string;
    MemoLabel1Caption: string;
    MemoLabel2Caption : string;
    InstallProcDeskriptionLabelCaption: string;

    { }
    RebootCaptionLabelCaptionReboot: string;
    RebootCaptionLabelCaptionEnd: string;
    RebootDeskriptionLabelContinueCaption : string;
    RebootDeskriptionLabelFinalCaption: string;
    RebootMsgLabelRebootCaption: string;
    RebootMsgLabelPowerOffCaption: string;
    RebootDeskriptionLabelCaption : string;
    NoRebootBtCaption: string;
    NoRebootBtHint: string;
    NoPowerOffBtCaption: string;
    NoPowerOffBtHint: string;

    
    {  }
    PostInstallCaptionLabelCaption: string;
    PostInstallDeskriptionLabelCaption: string;

    { }
    FinishCaptionLabelCaption : string;
    FinishDeskriptionLabelCaption : string;
    FinishLogDeskriptionLabelCaption: string;
    FinishBtCaption :string;
    FinishBtHint :string;
    LogMemoHint: string;

   {Config Form consts}
    ConfigFormCaption : string;
    ConfigFormCaptionAdm : string;

    ConfigHelpTextsAdm: array [0..4] of string;
    ConfigHelpTextsNorm: array [0..4] of string;
    ConfigHelpTextsPe: array [0..4] of string;
    ConfigHelpTextsPeAdm: array [0..4] of string;

    ConfigHelpMemoHint: string;
    ConfigHelpBtCaption: string;

    WelcomeLabelCaption: string;
    CopyLabelCaption: string;
    FinishLabelCaption: string;

    WelcomeLabelCaptionAdm: string;
    CopyLabelCaptionAdm: string;
    FinishLabelCaptionAdm: string;

    ConfigPowerOffCbCaption : string;
    ConfigPowerOffCbHint : string;

    ConfigFinishBtCaption: string;
    ConfigFinishBtHint: string;

    ConfigSaveBtCaption: string;
    ConfigSaveBtHint: string;

    ConfigNextBtCaption: string;
    ConfigNextBtHint: string;

    ConfigPrevBtCaption: string;
    ConfigPrevBtHint: string;

    ConfigCancelBtCaption : string;
    ConfigCancelBtHint: string;

    ConfigFastSelectCaption: string;
    ConfigFastSelectItems: string;
    ConfigFastSelectHint: string;

    ConfigAllSelectCaption:string;
    ConfigGroupSelectCaption:string;

    {Common}

    {  }
    HelpMbCaption: string;

    {  }
    ConfigHelpMbCaption : string;

    {  }
    ConfigErrorCaption: string;
    NoAttdMsg: string;
    NoConfigMsg: string;
    NoCloseDlgMsg:string;

    { }
    NoAdminRightsCaption: string;
    NoAdminRightsMsg: string;

    { }
    HintNoChangeSelect: string;
    HintNeedReboot: string;
    HintDependsItems: string;
    HintExcludeItems: string;

    { }
    NoDescriptionTitle: string;

    {  }
    SelectLogGroupName: string;
    SelectLogCommon: string;

    {RunOnce const}
    RunOnceTitle: string;
    RunOnceItemTitle: string;

    { }
    ConfirmRestartInstallCaption: string;
    ConfirmRestartInstallMsg: string;

    CANCEL_BT: string	= 'CANCEL_BT.bmp';
    CHECKALL_BT: string	= 'CHECKALL_BT.bmp';
    CHECKNONE_BT: string	= 'CHECKNONE_BT.bmp';
    CHECKDEF_BT: string	= 'CHECKDEF_BT.bmp';
    CHECKTG_BT: string	= 'CHECKTG_BT.bmp';
    CLOSE_BT: string	= 'CLOSE_BT.bmp';
    COLLAPSE_BT: string	= 'COLLAPSE_BT.bmp';
    EXPAND_BT: string	= 'EXPAND_BT.bmp';
    HELP_BT: string		= 'HELP_BT.bmp';
    LICCHECK_BT: string = 'LICCHECK_BT.bmp';
    LEFT_BT: string		= 'LEFT_BT.bmp';
    RIGHT_BT: string	= 'RIGHT_BT.bmp';
    TRAY_BT: string		= 'TRAY_BT.bmp';
    FINISH_BT: string		= 'FINISH_BT.bmp';
    GROUP_BIG: string	= 'GROUP_BIG.bmp';
    GROUP_SMALL: string	= 'GROUP_SMALL.bmp';
    PRCHECK_PICT: string	= 'PRCHECK_PICT.bmp';
    BULB_PICT: string	= 'BULB_PICT.bmp';
    TREESEL_BIG: string	= 'TREESELECTOR_BIG.bmp';
    TREESEL_SMALL: string	= 'TREESELECTOR_SMALL.bmp';
    LOGO_1024: string	= 'LOGO_1024.bmp';
    LOGO_640: string	= 'LOGO_640.bmp';
    LOGO_800: string	= 'LOGO_800.bmp';
    TOPWIZ_LOGO: string	= 'TOPWIZ_LOGO.bmp';
    LEFTWIZ_LOGO: string	= 'LEFTWIZ_LOGO.bmp';
    WALL_PICT: string	= 'WALLPAPERS.bmp';

    SND_CLICK: string	= 'CLICK.WAV';
    SND_OVER: string	= 'ACTIVATE.WAV';
    SND_DONE: string	= 'DONE.WAV';
    SND_BREAK: string	= 'BREAK.WAV';
    MIDI_BACKMIDI: string = 'BACKSND.MID';

    TmpTop     :integer = -1;
    TmpLeft    :integer = -1;
    TmpWidth   :integer = -1;
    TmpHeight  :integer = -1;

    StayOnTop: boolean = true;
    GlobalShowHint: boolean = true;
    GlobalCoolHint: boolean = true;
    GlobalExtendInfo: boolean = true;
    GlobalNoCollapseNode: boolean = false;
    ShortSelect: boolean = false;
    ABCCoord: boolean = false;
    Movable: boolean = false;
    ShowSkreenShots: boolean = false;
    StretchSkreenShots: byte = Ord(stReduce);
    MakeShotsEnable: boolean = false;
    AlphaBlendLevel: byte = 255;

    function  ValidateSkin(FileName:string):boolean;
    procedure LoadInterfaceSetting(FileName:string);
    procedure LoadLocalisedCommon(FileName:string);
    procedure LoadLocalisedConfigForm(FileName:string);
    procedure LoadLocalisedProcessForm(FileName:string);

implementation
 uses IniFiles, SysUtils, CommonProc;


function StringToColorDef(const S: string; DefColor: TColor): TColor;
begin
  if not IdentToColor(S, Longint(Result)) then
    Result := TColor(StrToIntDef(S,Integer(DefColor)));
end;

function  ValidateSkin(FileName:string):boolean;
begin
 result:=false;
 if not FileExists(FileName) then exit;
 result:=true;
 if CheckCmdParam('nocrc') then exit;
 with TIniFile.Create(FileName) do
  try
    result:=result and (SkinVer = ReadString('Common_Info','Ver',''));
    SkinAutor:= ReadString('Common_Info','Autor','NoName');
    SkinDescription:= ReadString('Common_Info','Description','No Description');
    SkinDate:= ReadString('Common_Info','Date','XX.XX.XX');
    result:=result and SectionExists('Interface');
    result:=result and SectionExists('FontMap');
    result:=result and SectionExists('ColorMap');
    result:=result and SectionExists('Skinset');
    result:=result and SectionExists('Sound');
    result:=result and SectionExists('ProcessForm');
    result:=result and SectionExists('ConfigForm');
    result:=result and SectionExists('CommonConst');
  finally
   free;
  end;
end;


procedure LoadInterfaceSetting(FileName:string);
begin
 if not FileExists(FileName) then exit;
 with TIniFile.Create(FileName) do
  try
    TmpTop:=Readinteger('Interface','Top',-1);
    TmpLeft:=Readinteger('Interface','Left',-1);
    TmpWidth:=Readinteger('Interface','Width',-1);
    TmpHeight:=Readinteger('Interface','Height',-1);
    StayOnTop:= ReadBool('Interface','StayOnTop',true);
    GlobalShowHint:= ReadBool('Interface','ShowHint',true);
    GlobalCoolHint:= ReadBool('Interface','CoolHint',true);
    GlobalPlaySound:= ReadBool('Interface','PlaySound',true);
    GlobalExtendInfo:= ReadBool('Interface','ExtendInfo',true);
    GlobalNoCollapseNode:= ReadBool('Interface','NoCollapseNode',true);
    ABCCoord:= ReadBool('Interface','ABCCoord',false);
    ShortSelect:= ReadBool('Interface','ShortMode',false);
    Movable:= ReadBool('Interface','Movable',false);
    ShowSkreenShots:= ReadBool('Interface','ShowSkreenShots',false);
    StretchSkreenShots:= Readinteger('Interface','StretchSkreenShots',Ord(stReduce));
    MakeShotsEnable:= ReadBool('Interface','MakeShotsEnable',false);
    AlphaBlendLevel:= Readinteger('Interface','AlphaBlendLevel',255);
    LabelFont:=ReadString('FontMap','LabelFont','Tahoma');
    BigLabelFont:=ReadString('FontMap','BigLabelFont','Arial');
    MemoFont:=ReadString('FontMap','MemoFont','Tahoma');
    TreeFont:=ReadString('FontMap','TreeFont','Tahoma');
    HintFont:=ReadString('FontMap','HintFont','Tahoma');
    CommonFont:=ReadString('FontMap','CommonFont','Tahoma');
    LabelColor:=StringToColorDef(ReadString('ColorMap','LabelColor',''), clWhite);
    LabelActiveColor:=StringToColorDef(ReadString('ColorMap','LabelActiveColor',''), $000080ff);
    ButtonFontColor:=StringToColorDef(ReadString('ColorMap','ButtonFontColor',''), clWhite);
    ButtonActiveFontColor:=StringToColorDef(ReadString('ColorMap','ButtonActiveFontColor',''), clHotLight);
    BigLabelColor:=StringToColorDef(ReadString('ColorMap','BigLabelColor',''), clWhite);
    BigLabelShadowColor:=StringToColorDef(ReadString('ColorMap','BigLabelShadowColor',''), $006D2500);
    MemoFontColor:=StringToColorDef(ReadString('ColorMap','MemoFontColor',''), clWhite);
    MemoColor:=StringToColorDef(ReadString('ColorMap','MemoColor',''), clNone);
    TreeFontColor:=StringToColorDef(ReadString('ColorMap','TreeFontColor',''), clWhite);
    TreeFontGroupColor:=StringToColorDef(ReadString('ColorMap','TreeFontGroupColor',''), clAqua);
    TreeColor:=StringToColorDef(ReadString('ColorMap','TreeColor',''), clNone);
    HintColor:=StringToColorDef(ReadString('ColorMap','HintColor',''), clInfoBk);
    HintFontColor:=StringToColorDef(ReadString('ColorMap','HintFontColor',''), clBlack);
    ProgressBackColor:=StringToColorDef(ReadString('ColorMap','ProgressBackColor',''), clWhite);
    ProgressColor:=StringToColorDef(ReadString('ColorMap','ProgressColor',''), clLime);
    RebotProgressColor:=StringToColorDef(ReadString('ColorMap','RebotProgressColor',''), clRed);
    CANCEL_BT:= ReadString('Skinset','CANCEL_BT','CANCEL_BT.bmp');
    CHECKALL_BT:= ReadString('Skinset','CHECKALL_BT','CHECKALL_BT.bmp');
    CHECKNONE_BT:= ReadString('Skinset','CHECKNONE_BT','CHECKNONE_BT.bmp');
    CHECKDEF_BT:= ReadString('Skinset','CHECKDEF_BT','CHECKDEF_BT.bmp');
    CHECKTG_BT:= ReadString('Skinset','CHECKTG_BT','CHECKTG_BT.bmp');
    LICCHECK_BT:= ReadString('Skinset','LICCHECK_BT','LICCHECK_BT.bmp');
    CLOSE_BT:= ReadString('Skinset','CLOSE_BT','CLOSE_BT.bmp');
    COLLAPSE_BT:= ReadString('Skinset','COLLAPSE_BT','COLLAPSE_BT.bmp');
    EXPAND_BT:= ReadString('Skinset','EXPAND_BT','EXPAND_BT.bmp');
    HELP_BT:= ReadString('Skinset','HELP_BT','HELP_BT.bmp');
    LEFT_BT:= ReadString('Skinset','LEFT_BT','LEFT_BT.bmp');
    RIGHT_BT:= ReadString('Skinset','RIGHT_BT','RIGHT_BT.bmp');
    TRAY_BT:= ReadString('Skinset','TRAY_BT','TRAY_BT.bmp');
    FINISH_BT:= ReadString('Skinset','FINISH_BT','FINISH_BT.bmp');
    GROUP_BIG:= ReadString('Skinset','GROUP_BIG','GROUP_BIG.bmp');
    GROUP_SMALL:= ReadString('Skinset','GROUP_SMALL','GROUP_SMALL.bmp');
    PRCHECK_PICT:= ReadString('Skinset','PRCHECK_PICT','PRCHECK_PICT.bmp');
    BULB_PICT:= ReadString('Skinset','BULB_PICT','BULB_PICT.bmp');
    TREESEL_BIG:= ReadString('Skinset','TREESEL_BIG','TREESELECTOR_BIG.bmp');
    TREESEL_SMALL:= ReadString('Skinset','TREESEL_SMALL','TREESELECTOR_SMALL.bmp');
    LOGO_1024:= ReadString('Skinset','LOGO_1024','LOGO_1024.bmp');
    LOGO_640:= ReadString('Skinset','LOGO_640','LOGO_640.bmp');
    LOGO_800:= ReadString('Skinset','LOGO_800','LOGO_800.bmp');
    TOPWIZ_LOGO:= ReadString('Skinset','TOPWIZ_LOGO','TOPWIZ_LOGO.bmp');
    LEFTWIZ_LOGO:= ReadString('Skinset','LEFTWIZ_LOGO','LEFTWIZ_LOGO.bmp');
    WALL_PICT:= ReadString('Skinset','WALLPAPERS','WALLPAPERS.bmp');
    SND_CLICK:= ReadString('Sound','CLICK','CLICK.WAV');
    SND_OVER:= ReadString('Sound','ACTIVATE','ACTIVATE.WAV');
    SND_DONE:= ReadString('Sound','DONE','DONE.WAV');
    SND_BREAK:= ReadString('Sound','BREAK','BREAK.WAV');
    MIDI_BACKMIDI:=ReadString('Sound','BACKMIDI','BACKSND.MID');
  finally
    free;
 end;
end;

procedure LoadLocalisedCommon(FileName:string);
begin
 if not FileExists(FileName) then exit;
 with TIniFile.Create(FileName) do
  try
    HelpMbCaption:=DelToLf(ReadString('CommonConst','HelpMbCaption',StrAbsent));
    ConfigHelpMbCaption :=DelToLf(ReadString('CommonConst','ConfigHelpMbCaption',StrAbsent));
    ConfigErrorCaption:=DelToLf(ReadString('CommonConst','ConfigErrorCaption',StrAbsent));
    NoAdminRightsCaption:=DelToLf(ReadString('CommonConst','NoAdminRightsCaption',StrAbsent));
    NoAdminRightsMsg:=DelToLf(ReadString('CommonConst','NoAdminRightsMsg',StrAbsent));
    NoAttdMsg:=DelToLf(ReadString('CommonConst','NoAttdMsg',StrAbsent));
    NoConfigMsg:=DelToLf(ReadString('CommonConst','NoConfigMsg',StrAbsent));
    NoCloseDlgMsg:=DelToLf(ReadString('CommonConst','NoCloseDlgMsg',StrAbsent));
    HintNoChangeSelect:=DelToLf(ReadString('CommonConst','HintNoChangeSelect',StrAbsent));
    HintNeedReboot:=DelToLf(ReadString('CommonConst','HintNeedReboot',StrAbsent));
    HintDependsItems:=DelToLf(ReadString('CommonConst','HintDependsItems',StrAbsent));
    HintExcludeItems:=DelToLf(ReadString('CommonConst','HintExcludeItems',StrAbsent));
    NoDescriptionTitle:=DelToLf(ReadString('CommonConst','NoDescriptionTitle',StrAbsent));
    SelectLogGroupName:=DelToLf(ReadString('CommonConst','SelectLogGroupName',StrAbsent));
    SelectLogCommon:=DelToLf(ReadString('CommonConst','SelectLogCommon','??? %d  %d'));
    RunOnceTitle:=DelToLf(ReadString('CommonConst','RunOnceTitle',StrAbsent));
    RunOnceItemTitle:=DelToLf(ReadString('CommonConst','RunOnceItemTitle',StrAbsent));
    ConfirmRestartInstallCaption:=DelToLf(ReadString('CommonConst','ConfirmRestartInstallCaption',StrAbsent));
    ConfirmRestartInstallMsg:=DelToLf(ReadString('CommonConst','ConfirmRestartInstallMsg',StrAbsent));
  finally
    free;
 end;
end;

procedure LoadLocalisedConfigForm(FileName:string);
begin
 if not FileExists(FileName) then exit;
 with TIniFile.Create(FileName) do
 try
  ConfigFormCaption :=DelToLf(ReadString('ConfigForm','ConfigFormCaption',StrAbsent));
  ConfigFormCaptionAdm :=DelToLf(ReadString('ConfigForm','ConfigFormCaptionAdm',StrAbsent));

  ConfigHelpTextsAdm[0]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextAdm0',StrAbsent));
  ConfigHelpTextsAdm[1]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextAdm1',StrAbsent));
  ConfigHelpTextsAdm[2]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextAdm2',StrAbsent));
  ConfigHelpTextsAdm[3]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextAdm3',StrAbsent));
  ConfigHelpTextsAdm[4]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextAdm4',StrAbsent));

  ConfigHelpTextsNorm[0]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextNorm0',StrAbsent));
  ConfigHelpTextsNorm[1]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextNorm1',StrAbsent));
  ConfigHelpTextsNorm[2]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextNorm2',StrAbsent));
  ConfigHelpTextsNorm[3]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextNorm3',StrAbsent));
  ConfigHelpTextsNorm[4]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextNorm4',StrAbsent));

  ConfigHelpTextsPe[0]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextPe0',StrAbsent));
  ConfigHelpTextsPe[1]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextPe1',StrAbsent));
  ConfigHelpTextsPe[2]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextPe2',StrAbsent));
  ConfigHelpTextsPe[3]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextPe3',StrAbsent));
  ConfigHelpTextsPe[4]:=DelToLf(ReadString('ConfigForm','ConfigHelpTextPe4',StrAbsent));

  ConfigHelpMemoHint :=DelToLf(ReadString('ConfigForm','HelpMemoHint',StrAbsent));
  WelcomeLabelCaption :=DelToLf(ReadString('ConfigForm','WelcomeLabelCaption',StrAbsent));
  CopyLabelCaption :=DelToLf(ReadString('ConfigForm','CopyLabelCaption',StrAbsent));
  FinishLabelCaption :=DelToLf(ReadString('ConfigForm','FinishLabelCaption',StrAbsent));
  WelcomeLabelCaptionAdm :=DelToLf(ReadString('ConfigForm','WelcomeLabelCaptionAdm',StrAbsent));
  CopyLabelCaptionAdm :=DelToLf(ReadString('ConfigForm','FinishLabelCaptionAdm',StrAbsent));
  FinishLabelCaptionAdm :=DelToLf(ReadString('ConfigForm','FinishLabelCaptionAdm',StrAbsent));
  ConfigHelpBtCaption :=DelToLf(ReadString('ConfigForm','HelpBtCaption',StrAbsent));
  ConfigPowerOffCbCaption :=DelToLf(ReadString('ConfigForm','PowerOffCbCaption',StrAbsent));
  ConfigPowerOffCbHint :=DelToLf(ReadString('ConfigForm','PowerOffCbHint',StrAbsent));
  ConfigFinishBtCaption :=DelToLf(ReadString('ConfigForm','FinishBtCaption',StrAbsent));
  ConfigFinishBtHint :=DelToLf(ReadString('ConfigForm','FinishBtHint',StrAbsent));
  ConfigNextBtCaption :=DelToLf(ReadString('ConfigForm','NextBtCaption',StrAbsent));
  ConfigNextBtHint :=DelToLf(ReadString('ConfigForm','NextBtHint',StrAbsent));
  ConfigPrevBtCaption :=DelToLf(ReadString('ConfigForm','PrevBtCaption',StrAbsent));
  ConfigPrevBtHint :=DelToLf(ReadString('ConfigForm','PrevBtHint',StrAbsent));
  ConfigCancelBtCaption :=DelToLf(ReadString('ConfigForm','CancelBtCaption',StrAbsent));
  ConfigCancelBtHint :=DelToLf(ReadString('ConfigForm','CancelBtHint',StrAbsent));
  ConfigFastSelectCaption :=DelToLf(ReadString('ConfigForm','FastSelectCaption',StrAbsent));
  ConfigFastSelectItems :=DelToLf(ReadString('ConfigForm','FastSelectItems',StrAbsent));
  ConfigFastSelectHint :=DelToLf(ReadString('ConfigForm','FastSelectHint',StrAbsent));
  ConfigSaveBtCaption :=DelToLf(ReadString('ConfigForm','SaveBtCaption',StrAbsent));
  ConfigSaveBtHint :=DelToLf(ReadString('ConfigForm','SaveBtHint',StrAbsent));
  ConfigAllSelectCaption :=DelToLf(ReadString('ConfigForm','AllSelectCaption',StrAbsent));
  ConfigGroupSelectCaption :=DelToLf(ReadString('ConfigForm','GroupSelectCaption',StrAbsent));
 finally
  free;
 end;
end;

procedure LoadLocalisedProcessForm(FileName:string);
begin
 if not FileExists(FileName) then exit;
 with TIniFile.Create(FileName) do
 try
    LabelCaptions[0]:=DelToLf(ReadString('ProcessForm','LabelCaptions1',StrAbsent));
    LabelCaptions[1]:=DelToLf(ReadString('ProcessForm','LabelCaptions2',StrAbsent));
    LabelCaptions[2]:=DelToLf(ReadString('ProcessForm','LabelCaptions3',StrAbsent));
    LabelCaptions[3]:=DelToLf(ReadString('ProcessForm','LabelCaptions4',StrAbsent));
    LabelCaptions[4]:=DelToLf(ReadString('ProcessForm','LabelCaptions5',StrAbsent));
    LabelCaptions[5]:=DelToLf(ReadString('ProcessForm','LabelCaptions6',StrAbsent));
    LabelCaptions[6]:=DelToLf(ReadString('ProcessForm','LabelCaptions7',StrAbsent));
    HelpTexts[0]:=DelToLf(ReadString('ProcessForm','HelpTexts0',StrAbsent));
    HelpTexts[1]:=DelToLf(ReadString('ProcessForm','HelpTexts1',StrAbsent));
    HelpTexts[2]:=DelToLf(ReadString('ProcessForm','HelpTexts2',StrAbsent));
    HelpTexts[3]:=DelToLf(ReadString('ProcessForm','HelpTexts3',StrAbsent));
    HelpTexts[4]:=DelToLf(ReadString('ProcessForm','HelpTexts4',StrAbsent));
    HelpTexts[5]:=DelToLf(ReadString('ProcessForm','HelpTexts5',StrAbsent));
    HelpTexts[6]:=DelToLf(ReadString('ProcessForm','HelpTexts6',StrAbsent));
    RestoreMiCaptionUp:=DelToLf(ReadString('ProcessForm','RestoreMiCaptionUp',StrAbsent));
    RestoreMiCaptionDown:=DelToLf(ReadString('ProcessForm','RestoreMiCaptionDown',StrAbsent));
    GrpLabelCaption:=DelToLf(ReadString('ProcessForm','GrpLabelCaption',StrAbsent));
    AllLabelCaption:=DelToLf(ReadString('ProcessForm','AllLabelCaption',StrAbsent));
    CollapseBtHint:=DelToLf(ReadString('ProcessForm','CollapseBtHint',StrAbsent));
    ExpandBtHint:=DelToLf(ReadString('ProcessForm','ExpandBtHint',StrAbsent));
    PrevBtCaption:=DelToLf(ReadString('ProcessForm','PrevBtCaption',StrAbsent));
    PrevBtHint:=DelToLf(ReadString('ProcessForm','PrevBtHint',StrAbsent));
    NextBtCaption:=DelToLf(ReadString('ProcessForm','NextBtCaption',StrAbsent));
    NextBtHint:=DelToLf(ReadString('ProcessForm','NextBtHint',StrAbsent));
    CloseBtHint:=DelToLf(ReadString('ProcessForm','CloseBtHint',StrAbsent));
    HelpBtHint:=DelToLf(ReadString('ProcessForm','HelpBtHint',StrAbsent));
    TrayBtHint:=DelToLf(ReadString('ProcessForm','TrayBtHint',StrAbsent));
    CheckAllBtCaption:=DelToLf(ReadString('ProcessForm','CheckAllBtCaption',StrAbsent));
    CheckAllBtHint:=DelToLf(ReadString('ProcessForm','CheckAllBtHint',StrAbsent));
    CheckNoneBtCaption:=DelToLf(ReadString('ProcessForm','CheckNoneBtCaption',StrAbsent));
    CheckNoneBtHint:=DelToLf(ReadString('ProcessForm','CheckNoneBtHint',StrAbsent));
    CheckDefBtCaption :=DelToLf(ReadString('ProcessForm','CheckDefBtCaption',StrAbsent));
    CheckDefBtHint:=DelToLf(ReadString('ProcessForm','CheckDefBtHint',StrAbsent));
    CheckRebootBtCaption:=DelToLf(ReadString('ProcessForm','CheckRebootBtCaption',StrAbsent));
    CheckRebootBtHint:=DelToLf(ReadString('ProcessForm','CheckRebootBtHint',StrAbsent));
    CheckPoweroffBtCaption:=DelToLf(ReadString('ProcessForm','CheckPoweroffBtCaption',StrAbsent));
    CheckPoweroffBtHint:=DelToLf(ReadString('ProcessForm','CheckPoweroffBtHint',StrAbsent));
    CheckCloseBtCaption :=DelToLf(ReadString('ProcessForm','CheckCloseBtCaption',StrAbsent));
    CheckCloseBtHint:=DelToLf(ReadString('ProcessForm','CheckCloseBtHint',StrAbsent));
    RebotModeCaption:=DelToLf(ReadString('ProcessForm','RebotModeCaption',StrAbsent));
    FastSelectCaption:=DelToLf(ReadString('ProcessForm','FastSelectCaption',StrAbsent));
    NoRebootBtCaption:=DelToLf(ReadString('ProcessForm','NoRebootBtCaption',StrAbsent));
    NoRebootBtHint:=DelToLf(ReadString('ProcessForm','NoRebootBtHint',StrAbsent));
    NoPowerOffBtCaption:=DelToLf(ReadString('ProcessForm','NoPowerOffBtCaption',StrAbsent));
    NoPowerOffBtHint:=DelToLf(ReadString('ProcessForm','NoPowerOffBtHint',StrAbsent));
    ScipBtCaption:=DelToLf(ReadString('ProcessForm','ScipBtCaption',StrAbsent));
    ScipBtHint:=DelToLf(ReadString('ProcessForm','ScipBtHint',StrAbsent));
    TestLabelCaption:=DelToLf(ReadString('ProcessForm','TestLabelCaption',StrAbsent));
    StartupCaptionLabelCaption:=DelToLf(ReadString('ProcessForm','StartupCaptionLabelCaption',StrAbsent));
    StartupDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','StartupDeskriptionLabelCaption',StrAbsent));
    StartupDeskriptionLabelNoWatCaption:=DelToLf(ReadString('ProcessForm','StartupDeskriptionLabelNoWatCaption',StrAbsent));
    StartupDeskriptionLabelWatCaption:=DelToLf(ReadString('ProcessForm','StartupDeskriptionLabelWatCaption',StrAbsent));
    StartupTimerCaptionCaption:=DelToLf(ReadString('ProcessForm','StartupTimerCaptionCaption',StrAbsent));
    StartupTimerCaptionHint:=DelToLf(ReadString('ProcessForm','StartupTimerCaptionHint',StrAbsent));
    LicenseCaptionLabelCaption:=DelToLf(ReadString('ProcessForm','LicenseCaptionLabelCaption',StrAbsent));
    LicenseDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','LicenseDeskriptionLabelCaption',StrAbsent));
    CheckLicenseConfirmBtCaption:=DelToLf(ReadString('ProcessForm','CheckLicenseConfirmBtCaption',StrAbsent));
    CheckLicenseConfirmBtHint:=DelToLf(ReadString('ProcessForm','CheckLicenseConfirmBtHint',StrAbsent));
    CheckLicenseCancelBtCaption:=DelToLf(ReadString('ProcessForm','CheckLicenseCancelBtCaption',StrAbsent));
    CheckLicenseCancelBtHint:=DelToLf(ReadString('ProcessForm','CheckLicenseCancelBtHint',StrAbsent));
    CheckLicenseLicenseDlgMsg:=DelToLf(ReadString('ProcessForm','CheckLicenseLicenseDlgMsg',StrAbsent));

    SelectorNextBtCaption:=DelToLf(ReadString('ProcessForm','SelectorNextBtCaption',StrAbsent));
    SelectorNextBtHint:=DelToLf(ReadString('ProcessForm','SelectorNextBtHint',StrAbsent));
    SelectorCaptionLabelCaption:=DelToLf(ReadString('ProcessForm','SelectorCaptionLabelCaption',StrAbsent));
    SelectorDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','SelectorDeskriptionLabelCaption',StrAbsent));
    ConfirmNextBtCaption:=DelToLf(ReadString('ProcessForm','ConfirmNextBtCaption',StrAbsent));
    ConfirmNextBtHint:=DelToLf(ReadString('ProcessForm','ConfirmNextBtHint',StrAbsent));
    ConfirmCaptionLabelCaption:=DelToLf(ReadString('ProcessForm','ConfirmCaptionLabelCaption',StrAbsent));
    ConfirmDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','ConfirmDeskriptionLabelCaption',StrAbsent));
    PostInstallCaptionLabelCaption:=DelToLf(ReadString('ProcessForm','PostInstallCaptionLabelCaption',StrAbsent));
    PostInstallDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','PostInstallDeskriptionLabelCaption',StrAbsent));
    ShowProgressCaptionLabelRestartCaption:=DelToLf(ReadString('ProcessForm','ShowProgressCaptionLabelRestartCaption',StrAbsent));
    ShowProgressCaptionLabelCaption :=DelToLf(ReadString('ProcessForm','ShowProgressCaptionLabelCaption',StrAbsent));
    PreInstallDeskriptionLabelCaption :=DelToLf(ReadString('ProcessForm','PreInstallDeskriptionLabelCaption',StrAbsent));
    PreInstallCaptionLabelCaption :=DelToLf(ReadString('ProcessForm','PreInstallCaptionLabelCaption',StrAbsent));
    MemoLabel1Caption:=DelToLf(ReadString('ProcessForm','MemoLabel1Caption',StrAbsent));
    MemoLabel2Caption :=DelToLf(ReadString('ProcessForm','MemoLabel2Caption',StrAbsent));
    InstallProcDeskriptionLabelCaption:=DelToLf(ReadString('ProcessForm','InstallProcDeskriptionLabelCaption',StrAbsent));
    RebootCaptionLabelCaptionReboot:=DelToLf(ReadString('ProcessForm','RebootCaptionLabelCaptionReboot',StrAbsent));
    RebootCaptionLabelCaptionEnd:=DelToLf(ReadString('ProcessForm','RebootCaptionLabelCaptionEnd',StrAbsent));
    RebootDeskriptionLabelContinueCaption :=DelToLf(ReadString('ProcessForm','RebootDeskriptionLabelContinueCaption',StrAbsent));
    RebootDeskriptionLabelFinalCaption:=DelToLf(ReadString('ProcessForm','RebootDeskriptionLabelFinalCaption',StrAbsent));
    RebootMsgLabelRebootCaption:=DelToLf(ReadString('ProcessForm','RebootMsgLabelRebootCaption',StrAbsent));
    RebootMsgLabelPowerOffCaption:=DelToLf(ReadString('ProcessForm','RebootMsgLabelPowerOffCaption',StrAbsent));
    RebootDeskriptionLabelCaption :=DelToLf(ReadString('ProcessForm','RebootDeskriptionLabelCaption',StrAbsent));
    FinishCaptionLabelCaption :=DelToLf(ReadString('ProcessForm','FinishCaptionLabelCaption',StrAbsent));
    FinishDeskriptionLabelCaption :=DelToLf(ReadString('ProcessForm','FinishDeskriptionLabelCaption',StrAbsent));
    FinishLogDeskriptionLabelCaption :=DelToLf(ReadString('ProcessForm','FinishLogDeskriptionLabelCaption',StrAbsent));
    FinishBtCaption :=DelToLf(ReadString('ProcessForm','FinishBtCaption',StrAbsent));
    FinishBtHint :=DelToLf(ReadString('ProcessForm','FinishBtHint',StrAbsent));
    SelectProgMemoHint:=DelToLf(ReadString('ProcessForm','SelectProgMemoHint',StrAbsent));
    LogMemoHint:=DelToLf(ReadString('ProcessForm','LogMemoHint',StrAbsent));
 finally
  free;
 end;
end;


end.
