{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }


program Presetup;

uses
  Forms,
  SysUtils,
  Windows,
  CommonProc,
  GlobalConst,
  SelectForm in 'SelectForm.pas' {SelectFm},
  NewProcess in 'NewProcess.pas' {NewProcessFm},
  Vimer in 'Vimer.pas' {RichVievFm};

{$R *.res}
{$R XpMan.res}


var
  MutexHandle: THandle;

begin
  SetThreadLocale(1049);
  MutexHandle := CreateMutex(nil, TRUE, 'BS_POST_INSTALLER');
   if MutexHandle <> 0 then
     begin
       if GetLastError = ERROR_ALREADY_EXISTS then
        begin
           if not CheckCmdParam('nomutex') then begin
            MessageBox(0, 'Possible start only one copy of this Program!',
                      AboutCaption, mb_IconHand);
            CloseHandle(MutexHandle);
            Halt;
           end;
          end
     end;
  Application.Initialize;
  if CheckCmdParam('config') then
  begin
    Application.CreateForm(TSelectFm, SelectFm);
  end
  else
  begin
   SetWindowLong(Application.Handle,GWL_EXSTYLE,
                GetWindowLong(Application.Handle,GWL_EXSTYLE) or
                (not WS_EX_APPWINDOW));
   Application.CreateForm(TNewProcessFm, NewProcessFm);
   //Application.ShowMainForm:=false;
  end;
  Application.Run;
end.
